QGIS Application - Bug report #4132
histogram gets needlessly refreshed twice - proposed fix
2011-08-02 09:31 AM - Etienne Tourigny

Status: Closed

Priority: Normal

Assignee:

Category: Rasters

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupls data: Copied to github as #: 14112
Description

If the Raster Histogram tab was previously selected in the Raster Properties dialog and the user opens the dialog again, the histogram is
refreshed twice, leading to needless processing and delay.

Specifically, in file src/app/qgsrasterlayerproperties.cpp the function QgsRasterLayerProperties::refreshHistogram() function gets called
twice, once by the QgsRasterLayerProperties constructor, and once by the on_tabBar_currentChanged() slot.

The histogram tab gets activated by this call
tabBar->setCurrentindex( settings.value( "/Windows/RasterLayerProperties/row" ).tolnt() );

A simple fix is to disable the call in the constructor (around line 280 in the master branch), and leave it in the
on_tabBar_currentChanged() slot.

QgsRasterLayerProperties::QgsRasterLayerProperties( QgsMapLayer* lyr, QgsMapCanvas* theCanvas, QWidget *parent,
Qt:WFlags fl )

setWindowTitle( tr( "Layer Properties - %1" ).arg( lyr->name() ) );

// int myHistogramTab = 6;

/1 if ( tabBar->currentindex() == myHistogramTab )

14

/I refreshHistogram();

I}

tableTransparency->horizontalHeader()->setResizeMode( 0, QHeaderView::Stretch );

tableTransparency->horizontalHeader()->setResizeMode( 1, QHeaderView::Stretch );
} // QgsRasterLayerProperties ctor

History

#1 - 2011-12-16 02:12 PM - Giovanni Manghi

- Target version set to Version 1.7.4

#2 - 2012-04-16 06:29 AM - Paolo Cavallini

- Crashes QGIS or corrupts data set to No

- Affected QGIS version set to master

- Target version changed from Version 1.7.4 to Version 1.8.0

#3 - 2012-06-18 12:51 PM - Etienne Tourigny
- Pull Request or Patch supplied changed from No to Yes
See
https://github.com/qgis/Quantum-GIS/pull/180
https://github.com/etiennesky/Quantum-GlIS/commit/c85d4e8d69bef6c753be699eef182e8c416887fc

#4 - 2012-09-04 11:58 AM - Paolo Cavallini
- Target version changed from Version 1.8.0 to Version 2.0.0

#5 - 2012-10-04 05:11 PM - Giovanni Manghi

- Resolution set to fixed
- Status changed from Open to Closed
